/*
 * NodePolyline2D.h
 *
 * Copyright (C) 1999 Stephen F. White
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#ifndef _NODE_POLYLINE_2D_H
#define _NODE_POLYLINE_2D_H

#ifndef _NODE_H
#include "Node.h"
#endif
#ifndef _PROTO_MACROS_H
#include "ProtoMacros.h"
#endif
#ifndef _PROTO_H
#include "Proto.h"
#endif

#include "SFMFTypes.h"

class ProtoPolyline2D : public Proto {
public:
                    ProtoPolyline2D(Scene *scene);
    virtual Node   *create(Scene *scene);

    FieldIndex point;
// X3D replaces point with lineSegments    FieldIndex lineSegments;
};

class NodePolyline2D : public Node {
public:
                    NodePolyline2D(Scene *scene, Proto *proto);

    virtual int     getType() const { return DUNE_POLYLINE_2D; }
    virtual int     getNodeClass() const { return NURBS_CONTROL_CURVE_NODE; }
    virtual int     getProfile(void) const { return PROFILE_IMMERSIVE; }
    virtual Node   *copy() const { return new NodePolyline2D(*this); }

    virtual bool    isInvalidChildNode(void) { return true; }
    virtual void    setField(int index, FieldValue *value);
    
    int             writeProto(int f);
    int             write(int filedes, int indent);
 
    fieldMacros(MFVec2f, point, ProtoPolyline2D)
};

#endif // _NODE_POLYLINE_2D_H
