/*
 * NodePosition2DInterpolator.cpp
 *
 * Copyright (C) 1999 Stephen F. White, 2007 J. "MUFTI" Scheurich
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include "stdafx.h"

#include "NodePosition2DInterpolator.h"
#include "Proto.h"
#include "FieldValue.h"
#include "MFFloat.h"
#include "MFVec2f.h"
#include "Scene.h"
#include "MFieldCommand.h"
#include "FieldCommand.h"
#include "CommandList.h"
#include "SFVec2f.h"

ProtoPosition2DInterpolator::ProtoPosition2DInterpolator(Scene *scene)
  : ProtoInterpolator(scene, "Position2DInterpolator", SFVEC2F, MFVEC2F, 
                      new MFVec2f())
{
}

Node *
ProtoPosition2DInterpolator::create(Scene *scene)
{ 
    return new NodePosition2DInterpolator(scene, this);
}

NodePosition2DInterpolator::NodePosition2DInterpolator(Scene *scene, Proto *def)
  : Interpolator(scene, def)
{
}

FieldValue *
NodePosition2DInterpolator::createKey(float *value) const
{
    FieldValue *r = new SFVec2f(value);
    delete value;
    return r;
}

FieldValue *
NodePosition2DInterpolator::createKeys(float *value, int numKeys) const
{
    return new MFVec2f(value, numKeys * 2);
}
