/*
 * x3dtranslators.cpp
 *
 * Copyright (C) 2001 J. "MUFTI" Scheurich
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file "COPYING" for details); if 
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
 * Cambridge, MA 02139, USA.
 */

#include "config.h"
#include "swt.h"
#include "DuneApp.h"
#include "x3dtranslators.h"
#include "MyString.h"

#ifndef WIN32
#include <stdlib.h>
#endif

static bool startCommand(char *systemCommand, char *what, char *settings, 
                         char* path, char* filepath) {
    char command[1024*3];
    bool hasSystemCommand = true;
    if (systemCommand == NULL) 
        hasSystemCommand = false;
    if (hasSystemCommand)
        if (strlen(systemCommand) == 0)
            hasSystemCommand = false;
    if (!hasSystemCommand) {
        char msg[1024];
        strcpy(msg, "no ");
        strcat(msg, what);
        strcat(msg, ". Use ");
        strcat(msg, settings);
        strcat(msg, " to select one");
        swMessageBox(TheApp->mainWnd(), msg, "Open", SW_MB_OK, SW_MB_WARNING);
        return false;
    }
    mysnprintf(command, 1024*3-1, "%s %s %s", systemCommand, path, filepath);
    if (system(command) !=0) {
        char msg[1024];
        mysnprintf(msg, 1024, "convertion to X3D (XML) of %s failed", path);
        swMessageBox(TheApp->mainWnd(), msg, "Open", SW_MB_OK, SW_MB_WARNING);
        return false;
    }
    return true;
}

/* convert VRML97 to x3d */

bool vrml2x3d(char* path, char* filepath) {
    return startCommand(TheApp->GetX3dv2X3dCommand(), 
                        "X3DV to X3D(XML) converter", 
                        "options->output settings...", path, filepath);
}

/* convert x3d to VRML97 */

bool x3d2vrml(char* path,char* filepath) {
    return startCommand(TheApp->GetX3d2X3dvCommand(), 
                        "X3D(XML) to X3DV converter", 
                        "options->input settings...", filepath, path);
}


