/* A Bison parser, made by GNU Bison 2.1.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     BRACKET_ON = 258,
     BRACKET_OFF = 259,
     WING_BRACKET_ON = 260,
     WING_BRACKET_OFF = 261,
     ID = 262,
     STRING = 263,
     INT_NUM = 264,
     FLOAT_NUM = 265,
     SCRIPT = 266,
     DEF = 267,
     EXTERNPROTO = 268,
     FALSE_TOK = 269,
     IS = 270,
     NULL_TOK = 271,
     PROTO = 272,
     ROUTE = 273,
     TO = 274,
     TRUE_TOK = 275,
     USE = 276,
     EVENT_IN = 277,
     EVENT_OUT = 278,
     EXPOSED_FIELD = 279,
     INPUT_OUTPUT = 280,
     FIELD = 281,
     X3D = 282,
     PROFILE = 283,
     COMPONENT = 284,
     META = 285,
     VRML1 = 286
   };
#endif
/* Tokens.  */
#define BRACKET_ON 258
#define BRACKET_OFF 259
#define WING_BRACKET_ON 260
#define WING_BRACKET_OFF 261
#define ID 262
#define STRING 263
#define INT_NUM 264
#define FLOAT_NUM 265
#define SCRIPT 266
#define DEF 267
#define EXTERNPROTO 268
#define FALSE_TOK 269
#define IS 270
#define NULL_TOK 271
#define PROTO 272
#define ROUTE 273
#define TO 274
#define TRUE_TOK 275
#define USE 276
#define EVENT_IN 277
#define EVENT_OUT 278
#define EXPOSED_FIELD 279
#define INPUT_OUTPUT 280
#define FIELD 281
#define X3D 282
#define PROFILE 283
#define COMPONENT 284
#define META 285
#define VRML1 286




/* Copy the first part of user declarations.  */
#line 24 "parser.y"

#include <stdio.h>
#include <stdlib.h>
#include "config.h"

#ifdef _WIN32
/* Ugly hack: redefine alloca to malloc */
#define alloca malloc
#endif

#include "stdafx.h"

#include "parser.h"
#include "Scene.h"
#include "Element.h"
#include "EventIn.h"
#include "EventOut.h"
#include "ExposedField.h"
#include "Field.h"
#include "FieldValue.h"

#include "SFMFTypes.h"

#include "Node.h"
#include "NodeScript.h"
#include "NodeNurbsSurface.h"
#include "NodeNurbsCurve.h"
#include "NodeComment.h"
#include "Proto.h"

#include "Stack.h"

extern void stopProto(void);

#define SYMB(id) (scene->getSymbol(id))
#define IS_OUTSIDE_PROTO "IS statement used outside PROTO"

Scene *scene;

#ifdef HAVE_LIBZ 
 gzFile inputFile;
#else
 FILE *inputFile;
#endif

int isInProtoLibrary = 0;

int lineno = 1;

Node *targetNode;
int targetField;

static Stack<Node *> nodeStack;
static Stack<Proto *> protoStack;
static int     defName = -1;
static int     currentType;
static NodeList commentNodeList;

static List<MyString> commentList;


static void    route(const MyString &srcNode, const MyString &srcField,
                     const MyString &dstNode, const MyString &dstField);
static Node   *newNode(const MyString &nodeType);

static int     checkField(Node *node, const MyString &fieldName);
static void    setField(Node *node, int index, FieldValue *value);
static void    isField(Node *node, const MyString &fieldName, const MyString &isName);
static FieldValue *intsToType(IntArray *floats, int type);
static FieldValue *floatsToType(DoubleArray *floats, int type);
static FieldValue *stringToType(const char* string, int type);
static DoubleArray *intsToFloats(IntArray *ints);
static DoubleArray *intsToDoubles(IntArray *ints);
static FieldValue *emptyMF(int type);
static FieldValue *emptyMFNodeOrNULL(int type);
static FieldValue *SillyDefaultValue(int type);
static MyString uniqName(const MyString name);
static MyString checkName(const MyString name);
static void repairURL(Node* node);
static void addCommentsToNode(Node* node);
static void addCommentsToNodeList(NodeList *nodelist);
static void addScriptElement(Element *element);

class nameTranslation {
public:
    MyString oldName;
    MyString newName;
    nameTranslation(MyString newN, MyString oldN)
       {
       newName = newN;
       oldName = oldN;
       }
};

Array<nameTranslation*> NameTranslation;

static bool x3d = false;

void setX3d(void) 
{
    x3d = true;
} 


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 128 "parser.y"
typedef union YYSTYPE {
    int                  int32;
    int                  id;
    Node                *node;
    NodeList            *nodeList;
    Element             *element;
    FieldValue          *value;
    float                sffloat;
    StringArray         *stringArray;
    IntArray            *intArray;
    DoubleArray         *doubleArray;
} YYSTYPE;
/* Line 196 of yacc.c.  */
#line 264 "y.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 219 of yacc.c.  */
#line 276 "y.tab.c"

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T) && (defined (__STDC__) || defined (__cplusplus))
# include <stddef.h> /* INFRINGES ON USER NAME SPACE */
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if defined (__STDC__) || defined (__cplusplus)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     define YYINCLUDED_STDLIB_H
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2005 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM ((YYSIZE_T) -1)
#  endif
#  ifdef __cplusplus
extern "C" {
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if (! defined (malloc) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if (! defined (free) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifdef __cplusplus
}
#  endif
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  11
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   196

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  34
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  52
/* YYNRULES -- Number of rules. */
#define YYNRULES  105
/* YYNRULES -- Number of states. */
#define YYNSTATES  185

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   286

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,    32,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    33,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     5,     8,    11,    14,    17,    19,    21,
      23,    25,    27,    28,    33,    36,    38,    40,    43,    45,
      46,    56,    60,    62,    65,    67,    68,    73,    77,    81,
      82,    88,    91,    93,    94,   100,   101,   109,   112,   114,
     118,   122,   126,   130,   139,   141,   142,   143,   149,   150,
     156,   159,   161,   164,   166,   168,   170,   176,   182,   186,
     189,   193,   195,   197,   199,   201,   203,   205,   207,   209,
     211,   213,   217,   219,   221,   225,   227,   229,   233,   237,
     240,   242,   244,   247,   249,   252,   255,   258,   260,   262,
     266,   268,   271,   273,   276,   279,   283,   287,   292,   294,
     297,   299,   302,   307,   309,   312
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      35,     0,    -1,    36,    -1,    79,    36,    -1,    31,    58,
      -1,     1,    58,    -1,    36,    37,    -1,    58,    -1,    38,
      -1,    40,    -1,    56,    -1,    59,    -1,    -1,    12,    67,
      39,    59,    -1,    21,    67,    -1,    42,    -1,    52,    -1,
      41,    40,    -1,    58,    -1,    -1,    17,    68,    43,     3,
      45,     4,     5,    44,     6,    -1,    41,    38,    36,    -1,
      58,    -1,    45,    50,    -1,    58,    -1,    -1,    26,    69,
      47,     7,    -1,    22,    69,     7,    -1,    23,    69,     7,
      -1,    -1,    25,    69,    49,     7,    72,    -1,    46,    72,
      -1,    48,    -1,    -1,    24,    69,    51,     7,    72,    -1,
      -1,    13,    68,    53,     3,    54,     4,    57,    -1,    54,
      55,    -1,    58,    -1,    22,    69,     7,    -1,    23,    69,
       7,    -1,    26,    69,     7,    -1,    24,    69,     7,    -1,
      18,    67,    32,     7,    19,    67,    32,     7,    -1,    76,
      -1,    -1,    -1,    68,     5,    60,    62,     6,    -1,    -1,
      11,     5,    61,    63,     6,    -1,    62,    65,    -1,    58,
      -1,    63,    64,    -1,    58,    -1,    65,    -1,    48,    -1,
      22,    69,     7,    15,     7,    -1,    23,    69,     7,    15,
       7,    -1,    46,    15,     7,    -1,    66,    72,    -1,     7,
      15,     7,    -1,    56,    -1,    40,    -1,     7,    -1,     7,
      -1,     7,    -1,     7,    -1,     7,    -1,     7,    -1,    73,
      -1,     8,    -1,     3,    77,     4,    -1,    38,    -1,    16,
      -1,     3,    78,     4,    -1,    74,    -1,    75,    -1,     3,
      74,     4,    -1,     3,    75,     4,    -1,     3,     4,    -1,
      20,    -1,    14,    -1,    74,     9,    -1,     9,    -1,    75,
      10,    -1,    75,     9,    -1,    74,    10,    -1,    10,    -1,
       8,    -1,     3,    77,     4,    -1,     8,    -1,    77,     8,
      -1,    38,    -1,    78,    38,    -1,    80,    81,    -1,    80,
      81,    82,    -1,    80,    81,    84,    -1,    80,    81,    82,
      84,    -1,    27,    -1,    28,    70,    -1,    83,    -1,    83,
      82,    -1,    29,    71,    33,     9,    -1,    85,    -1,    85,
      84,    -1,    30,     8,     8,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   166,   166,   171,   177,   178,   181,   186,   189,   190,
     191,   194,   195,   195,   198,   201,   202,   205,   206,   209,
     209,   227,   229,   232,   239,   242,   242,   246,   247,   248,
     248,   250,   255,   256,   256,   261,   260,   279,   286,   289,
     290,   291,   295,   301,   308,   310,   313,   313,   327,   327,
     343,   344,   347,   348,   351,   352,   353,   360,   368,   378,
     379,   382,   383,   388,   393,   396,   399,   403,   406,   410,
     411,   414,   416,   417,   418,   420,   421,   422,   423,   424,
     428,   429,   432,   433,   436,   437,   438,   441,   444,   445,
     449,   451,   454,   459,   466,   467,   468,   469,   472,   475,
     478,   479,   482,   484,   485,   488
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "BRACKET_ON", "BRACKET_OFF",
  "WING_BRACKET_ON", "WING_BRACKET_OFF", "ID", "STRING", "INT_NUM",
  "FLOAT_NUM", "SCRIPT", "DEF", "EXTERNPROTO", "FALSE_TOK", "IS",
  "NULL_TOK", "PROTO", "ROUTE", "TO", "TRUE_TOK", "USE", "EVENT_IN",
  "EVENT_OUT", "EXPOSED_FIELD", "INPUT_OUTPUT", "FIELD", "X3D", "PROFILE",
  "COMPONENT", "META", "VRML1", "'.'", "':'", "$accept", "vrmlScene",
  "statements", "statement", "nodeStatement", "@1", "protoStatement",
  "protoStatements", "proto", "@2", "protoBody", "interfaceDeclarations",
  "fieldDeclaration", "@3", "restrictedInterfaceDeclaration", "@4",
  "interfaceDeclaration", "@5", "externproto", "@6",
  "externInterfaceDeclarations", "externInterfaceDeclaration",
  "routeStatement", "URLList", "empty", "node", "@7", "@8", "nodeBody",
  "scriptBody", "scriptBodyElement", "nodeBodyElement", "fieldName",
  "nodeName", "nodeType", "fieldType", "profileId", "componentId",
  "fieldValue", "sfboolValue", "ints", "floats", "mfstringValue",
  "strings", "nodeStatements", "x3dHeaderStatement", "headerStatement",
  "profileStatement", "componentStatements", "componentStatement",
  "metaStatements", "metaStatement", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,    46,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    34,    35,    35,    35,    35,    36,    36,    37,    37,
      37,    38,    39,    38,    38,    40,    40,    41,    41,    43,
      42,    44,    44,    45,    45,    47,    46,    48,    48,    49,
      48,    48,    50,    51,    50,    53,    52,    54,    54,    55,
      55,    55,    55,    56,    57,    58,    60,    59,    61,    59,
      62,    62,    63,    63,    64,    64,    64,    64,    64,    65,
      65,    65,    65,    66,    67,    68,    69,    70,    71,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      73,    73,    74,    74,    75,    75,    75,    75,    76,    76,
      77,    77,    78,    78,    79,    79,    79,    79,    80,    81,
      82,    82,    83,    84,    84,    85
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     2,     2,     2,     1,     1,     1,
       1,     1,     0,     4,     2,     1,     1,     2,     1,     0,
       9,     3,     1,     2,     1,     0,     4,     3,     3,     0,
       5,     2,     1,     0,     5,     0,     7,     2,     1,     3,
       3,     3,     3,     8,     1,     0,     0,     5,     0,     5,
       2,     1,     2,     1,     1,     1,     5,     5,     3,     2,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     3,     1,     1,     3,     3,     2,
       1,     1,     2,     1,     2,     2,     2,     1,     1,     3,
       1,     2,     1,     2,     2,     3,     3,     4,     1,     2,
       1,     2,     4,     1,     2,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,    45,    98,    45,     0,     2,     7,    45,     0,     5,
       4,     1,    65,     0,     0,     0,     0,     0,     0,     6,
       8,     9,    15,    16,    10,    11,     0,     3,     0,    94,
      48,    64,    12,    35,    19,     0,    14,    46,    67,    99,
       0,     0,    95,   100,    96,   103,    45,     0,     0,     0,
       0,    45,    68,     0,     0,    97,   101,   104,    53,     0,
      13,    45,    45,     0,    51,     0,     0,   105,    49,    63,
       0,     0,     0,     0,    62,     0,    55,    61,    52,    54,
       0,     0,    38,     0,    24,     0,    47,    50,   102,     0,
      66,     0,     0,    29,    25,     0,    70,    83,    87,    81,
       0,    73,    80,    72,    31,    69,    75,    76,    59,     0,
       0,     0,     0,     0,    37,     0,     0,     0,     0,     0,
      32,    23,     0,    60,    27,    28,     0,     0,    79,    90,
      92,     0,     0,     0,     0,    58,    82,    86,    85,    84,
       0,    88,    36,    44,     0,     0,     0,     0,    45,     0,
       0,    33,     0,     0,     0,     0,    26,    77,    78,    71,
      91,    74,    93,     0,    39,    40,    42,    41,     0,     0,
      18,    27,    28,     0,    43,    56,    57,    30,    89,    45,
      17,    20,     0,    21,    34
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     4,     5,    19,   103,    47,    21,   168,    22,    49,
     169,    83,    75,   127,    76,   126,   121,   173,    23,    48,
      81,   114,    24,   142,     6,    25,    51,    46,    65,    59,
      78,    79,    80,    32,    26,    91,    39,    53,   104,   105,
     106,   107,   143,   133,   134,     7,     8,    29,    42,    43,
      44,    45
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -76
static const short int yypact[] =
{
      12,   -76,   -76,   -76,     8,    64,   -76,   -76,   -18,   -76,
     -76,   -76,   -76,    15,    35,    50,    50,    35,    35,   -76,
     -76,   -76,   -76,   -76,   -76,   -76,    29,    64,    71,    40,
     -76,   -76,   -76,   -76,   -76,    93,   -76,   -76,   -76,   -76,
      89,   122,   110,   117,   -76,   110,   -76,    21,   141,   145,
     143,   -76,   -76,   119,   148,   -76,   -76,   -76,   -76,    66,
     -76,   -76,   -76,   136,   -76,   147,   149,   -76,   -76,   142,
     152,   152,   152,   152,   -76,    90,   -76,   -76,   -76,   -76,
     106,    14,   -76,    42,   -76,    35,   -76,   -76,   -76,   154,
     -76,   155,   159,   -76,   -76,   124,   -76,   -76,   -76,   -76,
     160,   -76,   -76,   -76,   -76,   -76,    77,    85,   -76,   100,
     152,   152,   152,   152,   -76,   163,   152,   152,   152,   106,
     -76,   -76,   137,   -76,   156,   157,   167,   168,   -76,   -76,
     -76,    17,    41,    27,    37,   -76,   -76,   -76,   -76,   -76,
     162,   -76,   -76,   -76,   169,   170,   172,   173,   -76,   174,
     175,   -76,   176,   177,   178,   106,   -76,   -76,   -76,   -76,
     -76,   -76,   -76,   115,   -76,   -76,   -76,   -76,   130,   180,
     181,   -76,   -76,   182,   -76,   -76,   -76,   -76,   -76,   -76,
     -76,   -76,   106,    64,   -76
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
     -76,   -76,    -6,   -76,    -5,   -76,   -56,   -76,   -76,   -76,
     -76,   -76,   105,   -76,   107,   -76,   -76,   -76,   -76,   -76,
     -76,   -76,   -48,   -76,     1,   144,   -76,   -76,   -76,   -76,
     -76,   127,   -76,   -11,   123,   -57,   -76,   -76,   -75,   -76,
      98,    99,   -76,    55,   -76,   -76,   -76,   -76,   153,   -76,
      79,   -76
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -46
static const short int yytable[] =
{
      20,    27,     9,    74,    10,   108,    35,    36,    11,    74,
      28,    77,   -45,     1,    92,    93,    94,    77,   109,   -45,
      30,   157,    20,   -45,   -45,   -45,   136,   137,    12,   -45,
     -45,   159,    13,   -45,    37,   160,   110,   111,   112,     2,
     113,   161,    31,     3,    12,   158,   115,    58,    13,    14,
     138,   139,    64,   144,   145,   146,   147,    12,    18,   149,
     150,   151,    82,    84,   116,   117,   118,    72,    73,    40,
      41,    12,    68,    69,   122,    13,    14,    15,    38,    15,
     177,    16,    17,    16,    17,    18,   136,   137,    70,    71,
     130,    72,    73,    95,   138,   139,    52,    12,    96,    97,
      98,    13,    14,   140,    99,   100,   101,   184,   141,    95,
     102,    18,   180,    12,    96,    97,    98,    13,    14,   178,
      99,    55,   101,   160,    57,    50,   102,    18,   128,   162,
      54,    12,   129,    97,    98,    13,    14,    12,    33,    34,
      41,    13,    14,    15,    61,    18,    40,    16,    62,   170,
      63,    18,    66,    86,    69,    85,    67,    89,    88,    90,
      15,   123,   124,   179,    16,    17,   125,   135,   148,   152,
     129,   153,   154,   183,   155,   156,   164,   165,    20,   166,
     167,   171,   172,   174,   175,   176,   181,   -22,   119,   182,
     120,    60,    87,   131,   132,   163,    56
};

static const unsigned char yycheck[] =
{
       5,     7,     1,    59,     3,    80,    17,    18,     0,    65,
      28,    59,     0,     1,    71,    72,    73,    65,     4,     7,
       5,     4,    27,    11,    12,    13,     9,    10,     7,    17,
      18,     4,    11,    21,     5,     8,    22,    23,    24,    27,
      26,     4,     7,    31,     7,     4,     4,    46,    11,    12,
       9,    10,    51,   110,   111,   112,   113,     7,    21,   116,
     117,   118,    61,    62,    22,    23,    24,    25,    26,    29,
      30,     7,     6,     7,    85,    11,    12,    13,     7,    13,
     155,    17,    18,    17,    18,    21,     9,    10,    22,    23,
      95,    25,    26,     3,     9,    10,     7,     7,     8,     9,
      10,    11,    12,     3,    14,    15,    16,   182,     8,     3,
      20,    21,   168,     7,     8,     9,    10,    11,    12,     4,
      14,    42,    16,     8,    45,    32,    20,    21,     4,   134,
       8,     7,     8,     9,    10,    11,    12,     7,    15,    16,
      30,    11,    12,    13,     3,    21,    29,    17,     3,   148,
       7,    21,    33,     6,     7,    19,     8,    15,     9,     7,
      13,     7,     7,   168,    17,    18,     7,     7,     5,    32,
       8,    15,    15,   179,     7,     7,     7,     7,   183,     7,
       7,     7,     7,     7,     7,     7,     6,     6,    83,     7,
      83,    47,    65,    95,    95,   140,    43
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     1,    27,    31,    35,    36,    58,    79,    80,    58,
      58,     0,     7,    11,    12,    13,    17,    18,    21,    37,
      38,    40,    42,    52,    56,    59,    68,    36,    28,    81,
       5,     7,    67,    68,    68,    67,    67,     5,     7,    70,
      29,    30,    82,    83,    84,    85,    61,    39,    53,    43,
      32,    60,     7,    71,     8,    84,    82,    84,    58,    63,
      59,     3,     3,     7,    58,    62,    33,     8,     6,     7,
      22,    23,    25,    26,    40,    46,    48,    56,    64,    65,
      66,    54,    58,    45,    58,    19,     6,    65,     9,    15,
       7,    69,    69,    69,    69,     3,     8,     9,    10,    14,
      15,    16,    20,    38,    72,    73,    74,    75,    72,     4,
      22,    23,    24,    26,    55,     4,    22,    23,    24,    46,
      48,    50,    67,     7,     7,     7,    49,    47,     4,     8,
      38,    74,    75,    77,    78,     7,     9,    10,     9,    10,
       3,     8,    57,    76,    69,    69,    69,    69,     5,    69,
      69,    69,    32,    15,    15,     7,     7,     4,     4,     4,
       8,     4,    38,    77,     7,     7,     7,     7,    41,    44,
      58,     7,     7,    51,     7,     7,     7,    72,     4,    38,
      40,     6,     7,    36,    72
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname[yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 166 "parser.y"
    { 
                                  nodeComment();
                                  addCommentsToNodeList((yyvsp[0].nodeList));
                                  scene->addNodes(targetNode, targetField, (yyvsp[0].nodeList)); 
                                }
    break;

  case 3:
#line 171 "parser.y"
    { 
                                  scene->setX3dv();
                                  nodeComment();
                                  addCommentsToNodeList((yyvsp[0].nodeList));
                                  scene->addNodes(targetNode, targetField, (yyvsp[0].nodeList)); 
                                }
    break;

  case 6:
#line 181 "parser.y"
    {
                                  if ((yyvsp[0].node) != NULL) 
                                      (yyvsp[0].node)->appendTo((yyvsp[-1].nodeList)); 
                                  (yyval.nodeList) = (yyvsp[-1].nodeList); 
                                }
    break;

  case 7:
#line 186 "parser.y"
    { (yyval.nodeList) = new NodeList(); }
    break;

  case 8:
#line 189 "parser.y"
    { (yyval.node) = (yyvsp[0].node); }
    break;

  case 9:
#line 190 "parser.y"
    { (yyval.node) = NULL; }
    break;

  case 10:
#line 191 "parser.y"
    { (yyval.node) = NULL; }
    break;

  case 11:
#line 194 "parser.y"
    { scene->updateURLs((yyvsp[0].node)); (yyval.node) = (yyvsp[0].node); }
    break;

  case 12:
#line 195 "parser.y"
    { defName = (yyvsp[0].id); }
    break;

  case 13:
#line 195 "parser.y"
    { (yyval.node) = (yyvsp[0].node); 
                                                scene->updateURLs((yyvsp[0].node)); 
                                              }
    break;

  case 14:
#line 198 "parser.y"
    { (yyval.node) = scene->use(checkName(SYMB((yyvsp[0].id)))); }
    break;

  case 19:
#line 209 "parser.y"
    { 
                                   protoStack.push(new Proto(scene, SYMB((yyvsp[0].id))));
                                   if (!scene->addProtoName(SYMB((yyvsp[0].id)))) {
                                       char buf[1024];
                                       mysnprintf(buf,1024,
                                                  "proto already definied: %s",
                                                  (const char*)SYMB((yyvsp[0].id)));
                                       yyerror(buf);
                                   }  
                                 }
    break;

  case 20:
#line 221 "parser.y"
    { 
                                   scene->addProto(SYMB((yyvsp[-7].id)),protoStack.pop()); 
                                   stopProto();
                                 }
    break;

  case 21:
#line 228 "parser.y"
    { protoStack.peek()->define((yyvsp[-1].node), (yyvsp[0].nodeList)); }
    break;

  case 23:
#line 233 "parser.y"
    {
            if (protoStack.empty()) 
                yyerror("syntax error");
            else 
                protoStack.peek()->addElement((yyvsp[0].element));
          }
    break;

  case 25:
#line 242 "parser.y"
    { currentType = (yyvsp[0].int32); }
    break;

  case 26:
#line 243 "parser.y"
    { (yyval.element) = new Field((yyvsp[-2].int32), SYMB((yyvsp[0].id)), typeDefaultValue((yyvsp[-2].int32))); }
    break;

  case 27:
#line 246 "parser.y"
    { (yyval.element) = new EventIn((yyvsp[-1].int32), SYMB((yyvsp[0].id))); }
    break;

  case 28:
#line 247 "parser.y"
    { (yyval.element) = new EventOut((yyvsp[-1].int32), SYMB((yyvsp[0].id))); }
    break;

  case 29:
#line 248 "parser.y"
    { currentType = (yyvsp[0].int32); }
    break;

  case 30:
#line 249 "parser.y"
    { (yyval.element) = new ExposedField((yyvsp[-3].int32), SYMB((yyvsp[-1].id)), (yyvsp[0].value)); }
    break;

  case 31:
#line 250 "parser.y"
    { (yyval.element) = new Field((yyvsp[-1].element)->getType(), 
                                                         (yyvsp[-1].element)->getName(x3d), (yyvsp[0].value)); 
                                        }
    break;

  case 33:
#line 256 "parser.y"
    { currentType = (yyvsp[0].int32); }
    break;

  case 34:
#line 257 "parser.y"
    { (yyval.element) = new ExposedField((yyvsp[-3].int32), SYMB((yyvsp[-1].id)), (yyvsp[0].value)); }
    break;

  case 35:
#line 261 "parser.y"
    { 
                                  protoStack.push(new Proto(scene, SYMB((yyvsp[0].id)))); 
                                  if (!scene->addProtoName(SYMB((yyvsp[0].id)))) {
                                      char buf[1024];
                                      mysnprintf(buf,1024,
                                                 "proto already definied: %s",
                                                 (const char*)SYMB((yyvsp[0].id)));
                                      yyerror(buf);
                                   }
                                }
    break;

  case 36:
#line 272 "parser.y"
    { 
                                  scene->addProto(SYMB((yyvsp[-5].id)), protoStack.pop()); 
                                  scene->getProto(SYMB((yyvsp[-5].id)))->addURLs((yyvsp[0].value));
                                  stopProto();
                                }
    break;

  case 37:
#line 280 "parser.y"
    {
            if (protoStack.empty()) 
                yyerror("syntax error");
            else 
                protoStack.peek()->addElement((yyvsp[0].element));
          }
    break;

  case 39:
#line 289 "parser.y"
    { (yyval.element) = new EventIn((yyvsp[-1].int32), SYMB((yyvsp[0].id))); }
    break;

  case 40:
#line 290 "parser.y"
    { (yyval.element) = new EventOut((yyvsp[-1].int32), SYMB((yyvsp[0].id))); }
    break;

  case 41:
#line 291 "parser.y"
    { 
                                          (yyval.element) = new Field((yyvsp[-1].int32), SYMB((yyvsp[0].id)),
                                                         SillyDefaultValue((yyvsp[-1].int32)));
                                        }
    break;

  case 42:
#line 295 "parser.y"
    {
                                          (yyval.element) = new ExposedField((yyvsp[-1].int32), SYMB((yyvsp[0].id)),
                                                SillyDefaultValue((yyvsp[-1].int32)));
                                        }
    break;

  case 43:
#line 302 "parser.y"
    { 
               route(checkName(SYMB((yyvsp[-6].id))), SYMB((yyvsp[-4].id)), 
                     checkName(SYMB((yyvsp[-2].id))), SYMB((yyvsp[0].id))); 
             }
    break;

  case 46:
#line 313 "parser.y"
    { 
                                        (yyval.node) = newNode(SYMB((yyvsp[-1].id)));
                                        Node *node = (yyval.node);
                                        if (node != NULL) {
                                            addCommentsToNode((yyval.node));
                                            nodeStack.push((yyval.node));
                                            if (defName != -1) { 
                                                scene->def(uniqName(SYMB(
                                                       defName)), (yyval.node));
                                                defName = -1;
                                            }
                                        }
                                      }
    break;

  case 47:
#line 326 "parser.y"
    { (yyval.node) = nodeStack.pop(); }
    break;

  case 48:
#line 327 "parser.y"
    { 
                                        (yyval.node) = new NodeScript(scene);
                                        addCommentsToNode((yyval.node)); 
                                        nodeStack.push((yyval.node));
                                        if (defName != -1) { 
                                            scene->def(uniqName(SYMB(defName)), 
                                                       (yyval.node));
                                            defName = -1;
                                        }
                                      }
    break;

  case 49:
#line 337 "parser.y"
    { 
                                        (yyval.node) = nodeStack.pop(); 
                                        ((NodeScript *) (yyval.node))->update(); 
                                      }
    break;

  case 54:
#line 351 "parser.y"
    { (yyval.element) = NULL; }
    break;

  case 55:
#line 352 "parser.y"
    { addScriptElement((yyvsp[0].element)); }
    break;

  case 56:
#line 353 "parser.y"
    { if (protoStack.empty()) 
                                              yyerror(IS_OUTSIDE_PROTO); 
                                          (yyval.element) = new EventIn((yyvsp[-3].int32), SYMB((yyvsp[-2].id)));
                                          addScriptElement((yyval.element));
                                          isField(nodeStack.peek(),
                                                  SYMB((yyvsp[-2].id)), SYMB((yyvsp[0].id))); 
                                        }
    break;

  case 57:
#line 360 "parser.y"
    { if (protoStack.empty()) 
                                              yyerror(IS_OUTSIDE_PROTO); 
                                          (yyval.element) = new EventOut((yyvsp[-3].int32), SYMB((yyvsp[-2].id))); 
                                          addScriptElement((yyval.element));
                                          isField(nodeStack.peek(),
                                                  SYMB((yyvsp[-2].id)), SYMB((yyvsp[0].id))); 
                                        }
    break;

  case 58:
#line 368 "parser.y"
    { if (protoStack.empty())
                                              yyerror(IS_OUTSIDE_PROTO);
                                          (yyval.element) = (yyvsp[-2].element);
                                          addScriptElement((yyval.element));
                                          isField(nodeStack.peek(), 
                                                  (yyvsp[-2].element)->getName(x3d), SYMB((yyvsp[0].id)));
                                        }
    break;

  case 59:
#line 378 "parser.y"
    { setField(nodeStack.peek(), (yyvsp[-1].int32), (yyvsp[0].value)); }
    break;

  case 60:
#line 379 "parser.y"
    { isField(nodeStack.peek(),
                                                  SYMB((yyvsp[-2].id)), SYMB((yyvsp[0].id))); 
                                        }
    break;

  case 63:
#line 388 "parser.y"
    { (yyval.int32) = checkField(nodeStack.peek(),
                                                          SYMB((yyvsp[0].id))); 
                                        }
    break;

  case 66:
#line 399 "parser.y"
    { (yyval.int32) = typeStringToEnum(SYMB((yyvsp[0].id))); }
    break;

  case 70:
#line 411 "parser.y"
    { (yyval.value) = stringToType(SYMB((yyvsp[0].id)),
                                          currentType); 
                                        }
    break;

  case 71:
#line 415 "parser.y"
    { (yyval.value) = new MFString((yyvsp[-1].stringArray)); }
    break;

  case 72:
#line 416 "parser.y"
    { (yyval.value) = new SFNode((yyvsp[0].node)); }
    break;

  case 73:
#line 417 "parser.y"
    { (yyval.value) = emptyMFNodeOrNULL(currentType); }
    break;

  case 74:
#line 419 "parser.y"
    { (yyval.value) = new MFNode((yyvsp[-1].nodeList)); }
    break;

  case 75:
#line 420 "parser.y"
    { (yyval.value) = intsToType((yyvsp[0].intArray), currentType); }
    break;

  case 76:
#line 421 "parser.y"
    { (yyval.value) = floatsToType((yyvsp[0].doubleArray), currentType); }
    break;

  case 77:
#line 422 "parser.y"
    { (yyval.value) = intsToType((yyvsp[-1].intArray), currentType); }
    break;

  case 78:
#line 423 "parser.y"
    { (yyval.value) = floatsToType((yyvsp[-1].doubleArray), currentType); }
    break;

  case 79:
#line 424 "parser.y"
    { (yyval.value) = emptyMF(currentType); }
    break;

  case 80:
#line 428 "parser.y"
    { (yyval.value) = new SFBool(true); }
    break;

  case 81:
#line 429 "parser.y"
    { (yyval.value) = new SFBool(false); }
    break;

  case 82:
#line 432 "parser.y"
    { (yyvsp[-1].intArray)->append((yyvsp[0].int32)); (yyval.intArray) = (yyvsp[-1].intArray); }
    break;

  case 83:
#line 433 "parser.y"
    { (yyval.intArray) = new IntArray(); (yyval.intArray)->append((yyvsp[0].int32)); }
    break;

  case 84:
#line 436 "parser.y"
    { (yyvsp[-1].doubleArray)->append((yyvsp[0].sffloat)); (yyval.doubleArray) = (yyvsp[-1].doubleArray); }
    break;

  case 85:
#line 437 "parser.y"
    { (yyvsp[-1].doubleArray)->append((float) (yyvsp[0].int32)); (yyval.doubleArray) = (yyvsp[-1].doubleArray); }
    break;

  case 86:
#line 438 "parser.y"
    { (yyval.doubleArray) = intsToFloats((yyvsp[-1].intArray)); (yyval.doubleArray)->append((yyvsp[0].sffloat)); 
                                  delete (yyvsp[-1].intArray); 
                                }
    break;

  case 87:
#line 441 "parser.y"
    { (yyval.doubleArray) = new DoubleArray(); (yyval.doubleArray)->append((yyvsp[0].sffloat)); }
    break;

  case 88:
#line 444 "parser.y"
    { (yyval.value) = new MFString(SYMB((yyvsp[0].id))); }
    break;

  case 89:
#line 446 "parser.y"
    { (yyval.value) = new MFString((yyvsp[-1].stringArray)); }
    break;

  case 90:
#line 449 "parser.y"
    { (yyval.stringArray) = new StringArray();
                                  (yyval.stringArray)->append(SYMB((yyvsp[0].id))); }
    break;

  case 91:
#line 451 "parser.y"
    { (yyvsp[-1].stringArray)->append(SYMB((yyvsp[0].id))); (yyval.stringArray) = (yyvsp[-1].stringArray); }
    break;

  case 92:
#line 454 "parser.y"
    {
                                          (yyval.nodeList) = new NodeList();
                                          if ((yyvsp[0].node)) 
                                              (yyvsp[0].node)->appendTo((yyval.nodeList));
                                        }
    break;

  case 93:
#line 459 "parser.y"
    { 
                                          if ((yyvsp[0].node)) 
                                              (yyvsp[0].node)->appendTo((yyvsp[-1].nodeList)); 
                                          (yyval.nodeList) = (yyvsp[-1].nodeList);
                                        }
    break;


      default: break;
    }

/* Line 1126 of yacc.c.  */
#line 1909 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
	  YYSIZE_T yysize = yysize0;
	  YYSIZE_T yysize1;
	  int yysize_overflow = 0;
	  char *yymsg = 0;
#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
	  int yyx;

#if 0
	  /* This is so xgettext sees the translatable formats that are
	     constructed on the fly.  */
	  YY_("syntax error, unexpected %s");
	  YY_("syntax error, unexpected %s, expecting %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
#endif
	  char *yyfmt;
	  char const *yyf;
	  static char const yyunexpected[] = "syntax error, unexpected %s";
	  static char const yyexpecting[] = ", expecting %s";
	  static char const yyor[] = " or %s";
	  char yyformat[sizeof yyunexpected
			+ sizeof yyexpecting - 1
			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
			   * (sizeof yyor - 1))];
	  char const *yyprefix = yyexpecting;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 1;

	  yyarg[0] = yytname[yytype];
	  yyfmt = yystpcpy (yyformat, yyunexpected);

	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
		  {
		    yycount = 1;
		    yysize = yysize0;
		    yyformat[sizeof yyunexpected - 1] = '\0';
		    break;
		  }
		yyarg[yycount++] = yytname[yyx];
		yysize1 = yysize + yytnamerr (0, yytname[yyx]);
		yysize_overflow |= yysize1 < yysize;
		yysize = yysize1;
		yyfmt = yystpcpy (yyfmt, yyprefix);
		yyprefix = yyor;
	      }

	  yyf = YY_(yyformat);
	  yysize1 = yysize + yystrlen (yyf);
	  yysize_overflow |= yysize1 < yysize;
	  yysize = yysize1;

	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
	    yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg)
	    {
	      /* Avoid sprintf, as that infringes on the user's name space.
		 Don't have undefined behavior even if the translation
		 produced a string with the wrong number of "%s"s.  */
	      char *yyp = yymsg;
	      int yyi = 0;
	      while ((*yyp = *yyf))
		{
		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		    {
		      yyp += yytnamerr (yyp, yyarg[yyi++]);
		      yyf += 2;
		    }
		  else
		    {
		      yyp++;
		      yyf++;
		    }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    {
	      yyerror (YY_("syntax error"));
	      goto yyexhaustedlab;
	    }
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (YY_("syntax error"));
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (0)
     goto yyerrorlab;

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK;
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 490 "parser.y"


int yywrap(void)
{
    return 1;
}

void yyerror(char *s)
{
    scene->setErrorLineNumber(lineno);
#ifdef HAVE_LIBZ
    scene->errorf("%s in line %d\n", s, lineno);
#else
    if (strcmp(s,"parse error")==0)
        scene->errorf("%s (or %s) in line %d\n",
                      s, "unsupported compression (no gzip in this version)",
                      lineno);
    else
        scene->errorf("%s in line %d\n", s, lineno);
#endif
}

static Node *
newNode(const MyString &nodeType)
{
   Proto *proto;

   if (scene->getProtoPrefix() != NULL) {
       proto = scene->getExtensionProto(scene->getNodeWithPrefix(nodeType));
       if (proto)
           return proto->create(scene);
       }    
    proto = scene->getExtensionProto(nodeType);
    if (!proto) {
        scene->errorf("invalid node type %s in %d\n", 
                      (const char *) nodeType, lineno);
        return NULL;
    } else {
        return proto->create(scene);
    }
}

static FieldValue *
intsToType(IntArray *ints, int type)
{
    FieldValue *r = NULL;
    const int  *data = ints->getData();
    int len = ints->size();

    switch(type) {
      case SFCOLOR:
        if (len != 3) {
            yyerror("SFColor must have 3 values");
        } else {
            r = new SFColor((float) data[0], (float) data[1], (float) data[2]);
        }
        break;
      case SFCOLORRGBA:
        if (len != 4) {
            yyerror("SFColorRGBA must have 4 values");
        } else {
            r = new SFColorRGBA((float) data[0], (float) data[1],
                                (float) data[2], (float) data[3]);
        }
        break;
      case SFDOUBLE:
        if (len != 1) {
            yyerror("SFDouble must have 1 value");
        } else {
            r = new SFDouble((double) data[0]);
        }
        break;
      case SFFLOAT:
        if (len != 1) {
            yyerror("SFFloat must have 1 float value");
        } else {
            r = new SFFloat((float) data[0]);
        }
        break;
      case SFIMAGE:
        if (len < 3) {
            yyerror("SFImage must have at least 3 values");
        } else {
            int width = data[0];
            int height = data[1];
            int depth = data[2];

            if (len - 3 != width * height) {
                char buf[1024];
                mysnprintf(buf, 1024, "SFImage data must have %d values\n", 
                        width * height);
                yyerror(buf);
            } else {
                int *pixels = new int[len - 3];
                for (int i = 0; i < (len - 3); i++)
                    pixels[i] = data[i + 3];
                r = new SFImage(width, height, depth, pixels);
            }
        }
        break;
      case SFINT32:
        if (len != 1) {
            yyerror("SFInt32 must have 1 integer value");
        } else {
            r = new SFInt32(data[0]);
        }
        break;
      case SFROTATION:
        if (len != 4) {
            yyerror("SFRotation must have 4 values");
        } else {
            r = new SFRotation((float) data[0], (float) data[1], 
                               (float) data[2], (float) data[3]);
        }
        break;
      case SFTIME:
        if (len != 1) {
            yyerror("SFTime must have 1 value");
        } else {
            r = new SFTime((double) data[0]);
        }
        break;
      case SFVEC2F:
        if (len != 2) {
            yyerror("SFVec2f must have 2 values");
        } else {
            r = new SFVec2f((float) data[0], (float) data[1]);
        }
        break;
      case SFVEC3D:
        if (len != 3) {
            yyerror("SFVec3d must have 3 values");
        } else {
            r = new SFVec3d((double) data[0], (double) data[1], 
                            (double) data[2]);
        }
        break;
      case SFVEC3F:
        if (len != 3) {
            yyerror("SFVec3f must have 3 values");
        } else {
            r = new SFVec3f((float) data[0], (float) data[1], (float) data[2]);
        }
        break;
      case SFMATRIX3F:
        if (len != 9) {
            yyerror("SFMatrix3f must have 9 values");
        } else {
            r = new SFMatrix3f((float) data[0], 
                               (float) data[1], 
                               (float) data[2], 
                               (float) data[3], 
                               (float) data[4], 
                               (float) data[5], 
                               (float) data[6], 
                               (float) data[7], 
                               (float) data[8]);
        }
        break;
      case MFINT32:
        r = new MFInt32(ints->extractData(), len);
        break;
      case MFCOLOR:
      case MFCOLORRGBA:
      case MFFLOAT:
      case MFROTATION:
      case MFTIME:
      case MFVEC2F:
      case MFVEC3F:
        r = floatsToType(intsToFloats(ints), type);
        break;
      case MFDOUBLE:
      case MFVEC3D:
        r = floatsToType(intsToDoubles(ints), type);
        break;
      default:
        yyerror("type mismatch");
        break;
    }
    delete ints;
    return r;
}

static FieldValue *
floatsToType(DoubleArray *floats, int type)
{
    FieldValue     *r = NULL;
    const double   *data = floats->getData();
    int len = floats->size();

    switch(type) {
      case SFCOLOR:
        if (len != 3) {
            yyerror("SFColor must have 3 values");
        } else {
            r = new SFColor(data[0], data[1], data[2]);
        }
        break;
      case SFDOUBLE:
        if (len != 1) {
            yyerror("SFDouble must have 1 float value");
        } else {
            r = new SFDouble(data[0]);
        }
        break;
      case SFFLOAT:
        if (len != 1) {
            yyerror("SFFloat must have 1 float value");
        } else {
            r = new SFFloat(data[0]);
        }
        break;
      case SFROTATION:
        if (len != 4) {
            yyerror("SFRotation must have 4 values");
        } else {
            r = new SFRotation(data[0], data[1], data[2], data[3]);
        }
        break;
      case SFTIME:
        if (len != 1) {
            yyerror("SFTime must have 1 value");
        } else {
            r = new SFTime((double) data[0]);
        }
        break;
      case SFVEC2F:
        if (len != 2) {
            yyerror("SFVec2f must have 2 values");
        } else {
            r = new SFVec2f(data[0], data[1]);
        }
        break;
      case SFVEC3D:
        if (len != 3) {
            yyerror("SFVec3d must have 3 values");
        } else {
            r = new SFVec3d(data[0], data[1], data[2]);
        }
        break;
      case SFVEC3F:
        if (len != 3) {
            yyerror("SFVec3f must have 3 values");
        } else {
            r = new SFVec3f(data[0], data[1], data[2]);
        }
        break;
      case MFCOLOR:
        if (len % 3 != 0) {
            yyerror("MFColor must be a multiple of 3 values");
        } else {
            r = new MFColor(floats->extractData(), len);
        }
        break;
      case MFDOUBLE:
        r = new MFDouble(floats->extractData(), len);
        break;
      case MFFLOAT:
        r = new MFFloat(floats->extractData(), len);
        break;
      case MFROTATION:
        if (len % 4 != 0) {
            yyerror("MFRotation must be a multiple of 4 values");
        } else {
            r = new MFRotation(floats->extractData(), len);
        }
        break;
      case MFTIME:
        r = new MFTime(data, len);
        break;
      case MFVEC2F:
        if (len % 2 != 0) {
            yyerror("MFVec2f must be a multiple of 2 values");
        } else {
            r = new MFVec2f(floats->extractData(), len);
        }
        break;
      case MFVEC3D:
        if (len % 3 != 0) {
            yyerror("MFVec3d must be a multiple of 3 values");
        } else {
            r = new MFVec3d(floats->extractData(), len);
        }
        break;
      case MFVEC3F:
        if (len % 3 != 0) {
            yyerror("MFVec3f must be a multiple of 3 values");
        } else {
            r = new MFVec3f(floats->extractData(), len);
        }
        break;
      default:
        yyerror("type mismatch");
        break;
    }
    delete floats;
    return r;
}

static FieldValue *
stringToType(const char *string, int type)
{
    FieldValue     *r = NULL;

    switch(type) {
      case SFSTRING:
        r=new SFString(string);
        break;
      case MFSTRING:
        r=new MFString(string);
        break;
      default:
        yyerror("type mismatch");
        break;
    }
    return r;
}

static FieldValue *
emptyMFNodeOrNULL(int type)
{
    if (type==SFNODE)
       return new SFNode(NULL);
    else if (type==MFNODE)
       return emptyMF(type);
    else {
       /* NULL only allowed for Node types
          see VRML97 Grammar 
          http://www.web3d.org/x3d/specifications/vrml/ISO-IEC-14772-IS-VRML97WithAmendment1/part1/grammar.html
          sfnodeValue ::= 
              nodeStatement | 
              NULL ; 
       
       */
       yyerror("NULL only allowed for Node types, assuming \"[]\"");
       return emptyMF(type);
    }
}

static FieldValue *
emptyMF(int type)
{
    switch(type) {
      case MFCOLOR:
        return new MFColor();
      case MFFLOAT:
        return new MFFloat();
      case MFINT32:
        return new MFInt32();
      case MFNODE:
        return new MFNode();
      case MFROTATION:
        return new MFRotation();
      case MFSTRING:
        return new MFString();
      case MFTIME:
        return new MFTime();
      case MFVEC2F:
        return new MFVec2f();
      case MFVEC3F:
        return new MFVec3f();
      default:
        yyerror("type mismatch");
        return NULL;
    }
}

/*
 * Currently, EXTERNPROTO Definitions are not read
 * field need a senseful default value
 */

static FieldValue *
SillyDefaultValue(int type)
{
    if (scene->hasExternProtoWarning()) {
        fprintf(stderr,"Warning: Currently, EXTERNPROTO definitions are not read\n");
        fprintf(stderr,"Warning: Default field values of this EXTERNPROTO are incorrect\n");
    }

    if (FieldValue *value=typeDefaultValue(type))
       return value;
    else {
       yyerror("intern error: type no supported");
       return NULL;
    }
}

//
// checkField() - verify a field reference
//
// check that the node "node" has the field "fieldName"
// if not, print an error
// if so, stash its type in the lexer, and return its index

static int
checkField(Node *node, const MyString &fieldName)
{
    if (!node) return INVALID_INDEX;

    Proto *proto = node->getProto();

    if (!proto) return INVALID_INDEX;

    int index = proto->lookupField(fieldName, x3d);

    if (index == INVALID_INDEX) {
        scene->invalidField(proto->getName(x3d), fieldName);
    } else {
        currentType = proto->getField(index)->getType();
    }

    return index;
}


static void
setField(Node *node, int index, FieldValue *value)
{
    FieldValue *newValue;

    if (!node || !value || index < 0) return;

    Proto *proto = node->getProto();

    if (!proto) return;

    // TODO: handle x3d variants in a better way
    if (x3d && (node->getType() == DUNE_NURBS_SURFACE))
        if (index == ((NodeNurbsSurface *)node)->controlPoint_Field())
            index = ((NodeNurbsSurface *)node)->controlPointX3D_Field();
    if (x3d && (node->getType() == DUNE_NURBS_CURVE))
        if (index == ((NodeNurbsCurve *)node)->controlPoint_Field())
            index = ((NodeNurbsCurve *)node)->controlPointX3D_Field();

    Field *field = proto->getField(index);

    if (field == NULL) {
        scene->errorf("unknown/unsupported field 8-(\n");
        delete value;
        return;
    }

    if (value->getType() == SFSTRING && field->getType() == MFSTRING) {
        newValue = new MFString(((SFString *) value)->getValue());
        delete value;
        value = newValue;
    } else if (value->getType() == SFNODE && field->getType() == MFNODE) {
        NodeList *list = new NodeList();
        list->append(((SFNode *) value)->getValue());
        newValue = new MFNode(list);
        delete value;
        value = newValue;
    }

    if (value->getType() != field->getType()) {
        scene->errorf("type mismatch:  field \"%s\"\n", 
                      (const char *)field->getName(x3d));
        delete value;
    } else {
        scene->setField(node, index, value);
        if (TheApp->is4Catt())
            node->generateTreeLabel();
    }
}

static void
isField(Node *node, const MyString &fieldName, const MyString &isName)
{
    int srcField, srcEventIn, srcEventOut, srcExposedField;
    int dstField, dstEventIn, dstEventOut, dstExposedField;

    if (!node) return;

    Proto *source = node->getProto();

    if (!source) return;

    if (protoStack.empty()) {
        scene->errorf("IS statement used outside PROTO\n");
        return;
    }

    Proto *proto = protoStack.peek(); // wrong for recursive PROTOs 8-(

    if ((srcExposedField = source->lookupExposedField(fieldName, x3d)) != -1) {
        dstEventIn = proto->lookupEventIn(isName, x3d);
        dstEventOut = proto->lookupEventOut(isName, x3d);

        if ((dstExposedField = proto->lookupExposedField(isName, x3d)) != -1) {
            ExposedField *expField = proto->getExposedField(dstExposedField);
            if (expField != NULL) {
                int srcField = source->lookupField(fieldName, x3d);
                if (srcField != -1)
                    expField->addIs(node, srcField, EL_EXPOSED_FIELD,
                                    proto, dstExposedField);
            }
        } else if ((dstField = proto->lookupField(isName, x3d)) != -1) {
            Field *field = proto->getField(dstField);
            if (field != NULL) {
                int srcField = source->lookupField(fieldName, x3d);
                if (srcField != -1)
                    field->addIs(node, srcField, EL_EXPOSED_FIELD,
                                 proto, dstField);
            }
        } else if ((dstEventIn = proto->lookupEventIn(isName, x3d)) != -1) {
            EventIn *eventIn = proto->getEventIn(dstEventIn);
            if (eventIn != NULL)
                eventIn->addIs(node, srcExposedField, EL_EXPOSED_FIELD,
                               proto, dstEventIn, EIF_IS);
        } else if ((dstEventOut = proto->lookupEventOut(isName, x3d)) != -1) {
            EventOut *eventOut = proto->getEventOut(dstEventOut);
            if (eventOut != NULL)
                eventOut->addIs(node, srcExposedField, EL_EXPOSED_FIELD,
                                proto, dstEventOut, EOF_IS);
        } else {
            scene->invalidField(source->getName(x3d), isName);
        }
    } else if ((srcField = source->lookupField(fieldName, x3d)) != -1) {
        dstField = proto->lookupField(isName, x3d);
        if (dstField != -1) {
            Field *field = proto->getField(dstField);
            if (field != NULL)
                field->addIs(node, srcField, EL_FIELD_DEF, proto, dstField);
        } else {
            scene->invalidField(source->getName(x3d), isName);
        }
    } else if ((srcEventIn = source->lookupEventIn(fieldName, x3d)) != -1) {
        dstEventIn = proto->lookupEventIn(isName, x3d);
        if (dstEventIn != -1) {
            EventIn *eventIn = proto->getEventIn(dstEventIn);
            if (eventIn != NULL)
                eventIn->addIs(node, srcEventIn, EL_EVENT_IN, 
                               proto, dstEventIn, EIF_IS);
        } else {
            scene->invalidField(source->getName(x3d), isName);
        }
    } else if ((srcEventOut = source->lookupEventOut(fieldName, x3d)) != -1) {
        dstEventOut = proto->lookupEventOut(isName, x3d);
        if (dstEventOut != -1) {
            EventOut *eventOut = proto->getEventOut(dstEventOut);
            if (eventOut != NULL)
                eventOut->addIs(node, srcEventOut, EL_EVENT_OUT, 
                                proto, dstEventOut, EOF_IS);
        } else {
            scene->invalidField(source->getName(x3d), isName);
        }
    }
}

static void
route(const MyString &srcNode, const MyString &srcField,
      const MyString &dstNode, const MyString &dstField)
{
    int eventIn;
    int eventOut;
    bool valid = true;

    Node *src = scene->use(srcNode);
    if (!src) {
        scene->invalidNode(srcNode);
        valid = false;
    } else {
        eventOut = src->lookupEventOut(srcField, x3d);
        if (eventOut == INVALID_INDEX) {
            scene->errorf("node \"%s\" has no eventOut \"%s\"\n",
                          (const char *) srcNode, (const char *) srcField);
            valid = false;
        }
    }

    Node       *dst = scene->use(dstNode);
    if (!dst) {
        scene->invalidNode(dstNode);
        valid = false;
    } else {
        eventIn = dst->lookupEventIn(dstField, x3d);
        if (eventIn == INVALID_INDEX) {
            scene->errorf("node \"%s\" has no eventIn \"%s\"\n",
                          (const char *) dstNode, (const char *) dstField);
            valid = false;
        }
    }

    if (valid) {
        src->update();
        dst->update();
        if (!scene->addRoute(src, eventOut, dst, eventIn))
            scene->errorf("invalid ROUTE command in line %d\n",lineno);        
    }

}

static DoubleArray *
intsToFloats(IntArray *ints)
{
    if (ints == NULL ) return NULL;

    int len = ints->size();
    DoubleArray *r = new DoubleArray(len);
    const int *d = ints->getData();
    for (int i = 0; i < len; i++) {
        r->set(i, (float) d[i]);
    }
    return r;
}

static DoubleArray *
intsToDoubles(IntArray *ints)
{
    if (ints == NULL ) return NULL;

    int len = ints->size();
    DoubleArray *r = new DoubleArray(len);
    const int *d = ints->getData();
    for (int i = 0; i < len; i++) {
        r->set(i, (double) d[i]);
    }
    return r;
}

/* avoid double DEFs while file import */

static MyString
uniqName(const MyString name)
{
    int i=0;
    if (scene->hasAlreadyName(name)) {
        while (true) {
            int len = strlen((const char*) name) + 512;
            char* buf=(char*) malloc(len);
            mysnprintf(buf, len, "%s_%d", (const char*) name, i++);
            MyString* newName=new MyString(buf);
            free(buf);
            if (!scene->hasAlreadyName(*newName)) {
                NameTranslation.append(new nameTranslation(*newName,name));
                return *newName;
            }
        }
    }
    return name;
}

/* replace double DEFs while file import */

static MyString
checkName(const MyString name)
{
    for (int i=NameTranslation.size()-1;i>=0;i--)
        if (name==NameTranslation[i]->oldName) {
            return NameTranslation[i]->newName;
        }
    return name;
}

void forgetNameTranslation(void)
{
    NameTranslation.resize(0);
}

static void 
addCommentsToNode(Node* node)
{
    if (commentNodeList.size() > 0) {
        for (int i = 0;i < commentNodeList.size(); i++)
            node->appendComment(commentNodeList[i]);
        commentNodeList.resize(0);
    }
}

static void 
addCommentsToNodeList(NodeList *nodelist)
{
    if (commentNodeList.size() > 0) {
        for (int i = 0;i < commentNodeList.size(); i++)
            nodelist->append(commentNodeList[i]);
        commentNodeList.resize(0);
    }    
}

static void addScriptElement(Element *element)
{
    if (nodeStack.empty()) 
        yyerror("syntax error");
    else 
    if (element) { 
        nodeStack.peek()->getProto()->addElement(element);
        nodeStack.peek()->update();
        if (element->getElementType() == EL_FIELD_DEF) {
            Field *field = (Field *)element;
            // search for number of field to use setField 
            Proto *proto =  nodeStack.peek()->getProto();
            for (int i=0; i < proto->getNumFields(); i++)
                if (proto->getField(i)->getName(x3d) == field->getName(x3d))
                    setField(nodeStack.peek(), i, field->getDefault());
        }
    }
}

void
addToCurrentComment(char *string)
{
   if (strlen(string) > 0)
       commentList.append(string);
}

void
nodeComment(void)
{
    if (commentList.size()!=0) {
        StringArray *mfString = new StringArray();
        for (List<MyString>::Iterator* commentpointer = commentList.first();
            commentpointer != NULL; commentpointer = commentpointer->next() ) {
            const char *string = commentpointer->item();
            bool isVRMLheader = false;
            if (strcmp(string, "#VRML V2.0 utf8") == 0) 
                isVRMLheader = true;
            if (!isVRMLheader) {
                if (string[0] == '\n')
                    string++;
                mfString->append(mystrdup(++string));
            }
        }
        if (mfString->size() > 0) {
            NodeComment *node = (NodeComment *) scene->createNode("#");
            node->comment(new MFString(mfString));
            commentNodeList.append(node);
        }
        commentList.removeAll();
    }
}

void
insideNodeComment(void)
{
}

void
MFComment(void)
{
}

void
insideMFComment(void)
{
}


